# faxsuite_res_tful_api

FaxsuiteResTfulApi - JavaScript client for faxsuite_res_tful_api
<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 4.0.0
- Package version: 4.0.0
- Build package: io.swagger.codegen.v3.generators.javascript.JavaScriptClientCodegen
For more information, please visit [https://www.fax-api.de/support/](https://www.fax-api.de/support/)

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install faxsuite_res_tful_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var FaxsuiteResTfulApi = require('faxsuite_res_tful_api');
var defaultClient = FaxsuiteResTfulApi.ApiClient.instance;

// Configure API key authorization: ApiAuthKey
var ApiAuthKey = defaultClient.authentications['ApiAuthKey'];
ApiAuthKey.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//ApiAuthKey.apiKeyPrefix['X-Auth-Token'] = "Token"

var api = new FaxsuiteResTfulApi.JobDetailsApi()
var id = "id_example"; // {String} Identification number (UUID) of the job

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.getJob(id, callback);
```

## Documentation for API Endpoints

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*FaxsuiteResTfulApi.JobDetailsApi* | [**getJob**](docs/JobDetailsApi.md#getJob) | **GET** /jobs/{id} | /jobs/{id}
*FaxsuiteResTfulApi.JobDetailsApi* | [**getJobNotifications**](docs/JobDetailsApi.md#getJobNotifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
*FaxsuiteResTfulApi.JobDetailsApi* | [**getJobPreviews**](docs/JobDetailsApi.md#getJobPreviews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
*FaxsuiteResTfulApi.JobDetailsApi* | [**getJobRecipients**](docs/JobDetailsApi.md#getJobRecipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
*FaxsuiteResTfulApi.JobDetailsApi* | [**getJobTemplates**](docs/JobDetailsApi.md#getJobTemplates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
*FaxsuiteResTfulApi.JobDetailsApi* | [**putJob**](docs/JobDetailsApi.md#putJob) | **PUT** /jobs/{id} | /jobs/{id}
*FaxsuiteResTfulApi.JobsApi* | [**getJobs**](docs/JobsApi.md#getJobs) | **GET** /jobs | /jobs
*FaxsuiteResTfulApi.JobsApi* | [**postJob**](docs/JobsApi.md#postJob) | **POST** /jobs | /jobs
*FaxsuiteResTfulApi.RecipientsApi* | [**getRecipients**](docs/RecipientsApi.md#getRecipients) | **GET** /recipients | /recipients
*FaxsuiteResTfulApi.SystemApi* | [**getHealth**](docs/SystemApi.md#getHealth) | **GET** /health | /health

## Documentation for Models

 - [FaxsuiteResTfulApi.ErrorAuthenticationResponse](docs/ErrorAuthenticationResponse.md)
 - [FaxsuiteResTfulApi.ErrorBadRequestResponse](docs/ErrorBadRequestResponse.md)
 - [FaxsuiteResTfulApi.ErrorInternalServerResponse](docs/ErrorInternalServerResponse.md)
 - [FaxsuiteResTfulApi.ErrorNotFoundResponse](docs/ErrorNotFoundResponse.md)
 - [FaxsuiteResTfulApi.ErrorServiceNotAvailableResponse](docs/ErrorServiceNotAvailableResponse.md)
 - [FaxsuiteResTfulApi.ErrorToManyRequestsResponse](docs/ErrorToManyRequestsResponse.md)
 - [FaxsuiteResTfulApi.Health](docs/Health.md)
 - [FaxsuiteResTfulApi.InlineResponse201](docs/InlineResponse201.md)
 - [FaxsuiteResTfulApi.Job](docs/Job.md)
 - [FaxsuiteResTfulApi.JobInfo](docs/JobInfo.md)
 - [FaxsuiteResTfulApi.JobOptions](docs/JobOptions.md)
 - [FaxsuiteResTfulApi.JobPost](docs/JobPost.md)
 - [FaxsuiteResTfulApi.JobPostOptions](docs/JobPostOptions.md)
 - [FaxsuiteResTfulApi.JobPostRecipient](docs/JobPostRecipient.md)
 - [FaxsuiteResTfulApi.JobRecipient](docs/JobRecipient.md)
 - [FaxsuiteResTfulApi.JobRecipients](docs/JobRecipients.md)
 - [FaxsuiteResTfulApi.JobStatistics](docs/JobStatistics.md)
 - [FaxsuiteResTfulApi.Jobs](docs/Jobs.md)
 - [FaxsuiteResTfulApi.JobsIdBody](docs/JobsIdBody.md)
 - [FaxsuiteResTfulApi.Notification](docs/Notification.md)
 - [FaxsuiteResTfulApi.Notifications](docs/Notifications.md)
 - [FaxsuiteResTfulApi.Preview](docs/Preview.md)
 - [FaxsuiteResTfulApi.Recipient](docs/Recipient.md)
 - [FaxsuiteResTfulApi.RecipientJob](docs/RecipientJob.md)
 - [FaxsuiteResTfulApi.Recipients](docs/Recipients.md)
 - [FaxsuiteResTfulApi.Template](docs/Template.md)
 - [FaxsuiteResTfulApi.Templates](docs/Templates.md)

## Documentation for Authorization


### ApiAuthKey

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header

